#pragma once

#include <string>
#include <algorithm>

namespace ioc
{
    double calculate_fitness(const std::string &text);
}

namespace quadgrams
{
    double calculate_fitness(const std::string &text);
}

namespace sinkov
{
    double calculate_fitness(const std::string &text);
}

inline void cleanCipher(std::string &cipher)
{
    cipher.erase(std::remove_if(cipher.begin(), cipher.end(), isspace), cipher.end());
}

inline int countOccurences(const std::string &text, std::array<double, 26>& counts)
{
    int total = 0;
    counts.fill(0.0);
    for (auto letter : text)
    {
        int letterCode = letter - 'A';
        if (letterCode < 0 || letterCode > 25)
            continue;

        counts[letterCode]++;
        total++;
    }

    return total;
}
